package com.realnet.basic.Controllers;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import com.fasterxml.jackson.core.JsonProcessingException;
import org.springframework.web.bind.annotation.CrossOrigin;
import com.fasterxml.jackson.databind.JsonMappingException;
import com.realnet.config.EmailService;
import com.realnet.users.entity1.AppUser;
import com.realnet.users.service1.AppUserServiceImpl;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.data.domain.*;
import com.realnet.fnd.response.EntityResponse;
import org.springframework.http.*;
import org.springframework.beans.factory.annotation.*;
import com.realnet.basic.Entity.Tasks;
import com.realnet.basic.Services.TasksService ;




@RequestMapping(value = "/Tasks")
 @CrossOrigin("*") 
@RestController
public class TasksController {
	@Autowired
	private TasksService Service;

@Value("${projectPath}")
	private String projectPath;
 




	@PostMapping("/Tasks")
		  public Tasks Savedata(@RequestBody Tasks data) {
		Tasks save = Service.Savedata(data)	;



		System.out.println("data saved..." + save);

 return save;
	  }
@PutMapping("/Tasks/{id}")
	public  Tasks update(@RequestBody Tasks data,@PathVariable Integer id ) {
		Tasks update = Service.update(data,id);
		System.out.println("data update..." + update);
		return update;
	}	 
//	get all with pagination
	@GetMapping("/Tasks/getall/page")
	public Page<Tasks> getall(@RequestParam(value = "page", required = false) Integer page,
			@RequestParam(value = "size", required = false) Integer size) {
		Pageable paging = PageRequest.of(page, size);
		Page<Tasks> get = Service.getAllWithPagination(paging);

		return get;

	}	
	@GetMapping("/Tasks")
	public List<Tasks> getdetails() {
		 List<Tasks> get = Service.getdetails();		
		return get;
}
// get all without authentication 

	@GetMapping("/token/Tasks")
	public List<Tasks> getallwioutsec() {
		 List<Tasks> get = Service.getdetails();		
		return get;
}
@GetMapping("/Tasks/{id}")
	public  Tasks  getdetailsbyId(@PathVariable Integer id ) {
		Tasks  get = Service.getdetailsbyId(id);
		return get;
	}
@DeleteMapping("/Tasks/{id}")
	public  ResponseEntity<?> delete_by_id(@PathVariable Integer id ) {
	Service.delete_by_id(id);
			return new ResponseEntity<>(new EntityResponse("Deleted"), HttpStatus.OK);
	
	}





}